#!/bin/bash

echo "# $0: running as: $(id)"
echo "# $0: running in: $(pwd)"
echo "# $0: initial environment:"
env | LC_ALL=C sort | sed -e 's/^/#  /'

echo "# $0: Xorg.log:"
cat /var/log/Xorg.0.log | sed -e 's/^/#  /'

echo "# $0: System journal:"
sudo journalctl | sed -e 's/^/#  /'

# Debuggability
set -x

# Report non-rightmost failing status in pipelines.
set -e
set -o pipefail

/usr/lib/chaiwala-tests/x-out-of-screen-events/input_generator 2>&1 | sed -e 's/^/# input_generator:  /' &
sleep 2
buttond /usr/share/chaiwala-tests/x-out-of-screen-events/buttond_tester.conf 2>&1 | sed -e 's/^/# buttond:  /' &
sleep 2
xinput set-prop "Event Testing Device" "Evdev Axis Calibration" 0 300 0 2000 2>&1 | sed -e 's/^/# xinput:  /'
unbuffer xinput test "VIRTUAL KEYBOARD" > keys.out &
sleep 5

pkill -SIGUSR1 input_generator
wait %1
pkill xinput || true  # xinput may exit cleanly of its own accord

diff -u keys.out /usr/share/chaiwala-tests/x-out-of-screen-events/keys.ref 2>&1 | sed -e 's/^/# diff:  /'
echo "x-out-of-screen-events-buttond: PASSED"
